﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using Telerik.Windows.Data;
using System.Collections.Specialized;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DataContext = new NorthwindEntities();
        }
    }

    public partial class NorthwindEntities
    {
        ICollectionView _ProductsCollection;
        public ICollectionView ProductsCollection
        {
            get
            {
                if (_ProductsCollection == null)
                {
                    _ProductsCollection = new QueryableCollectionView(Products.ToList());
                    _ProductsCollection.CollectionChanged += (s, e) =>
                        {
                            if (e.Action == NotifyCollectionChangedAction.Remove)
                            {
                                e.OldItems.Cast<Product>().ToList().ForEach(Products.DeleteObject);
                            }
                            else if (e.Action == NotifyCollectionChangedAction.Add)
                            {
                                e.NewItems.Cast<Product>().ToList().ForEach(Products.AddObject);
                            }

                        };
                }
                return _ProductsCollection;
            }
        }
    }

    public partial class Product : IEditableObject
    {
        #region IEditableObject Members

        public void BeginEdit()
        {
            //throw new NotImplementedException();
        }

        public void CancelEdit()
        {
            //throw new NotImplementedException();
        }

        public void EndEdit()
        {
            //throw new NotImplementedException();
        }

        #endregion
    }
}
